#! /usr/bin/env python3 -B

from testlib import check, runtests
from json import load

import program

def test_program_1a():
    "\nPrimo test della funzione es1 con testo= 'lo zaino pesa' e k=2\n"
    expected    = 'nq bckpq rguc'
    explanation1 = "il testo  crittografato restituito non e' corretto"
    returned    = program.es1('lo zaino pesa',2)
    check(returned, expected, None, explanation1 )
    return 1
    
def test_program_1b():
    "\nSecondo test della funzione es1 con testo= 'lo zaino pesa' e k=79\n"
    expected    = 'mp abjop qftb'
    explanation1 = "il testo  crittografato restituito non e' corretto"
    returned    = program.es1('lo zaino pesa',79)
    check(returned, expected, None, explanation1 )
    return 1

def test_program_2a():
    "\nPrimo test della funzione es2 con dizionario= {1:[1,2,3],2:[1,2,4]}\n"
    expected    = {1: 2, 2: 2, 3: 1, 4: 2}
    explanation1 = "il dizionario restituito non e' corretto"
    returned    = program.es2({1:[1,2,3],2:[1,2,4]})
    check(returned, expected, None, explanation1 )
    return 1
    
def test_program_2b():
    "\nSecondo test della funzione es2 con dizionario= {1:[5,6,7,8],2:[5,6,7],3:[5,6],4:[5]}\n"
    expected    = {5: 4, 6: 3, 7: 2, 8: 1}
    explanation1 = "il dizionario restituito non e' corretto"
    returned    = program.es2({1:[5,6,7,8],2:[5,6,7],3:[5,6],4:[5]})
    check(returned, expected, None, explanation1 )
    return 1

def test_program_3a():
    "\nPrimo test della funzione es3 sulla tabella [[3,2,1,0],[2,1,3,5],[1,3,2,1]]\n"
    tabella=[[3,2,1,0],[2,1,3,5],[1,3,2,1]]
    expected    = [[1, 1, 1, 0], [2, 2, 2, 1], [3, 3, 3, 5]]
    explanation1 = "il numero di elementi della tabella restituito  non e' corretto"
    explanation2 = "la tabella non e' stata modificata correttamente"
    returned    = program.es3(tabella)
    check(returned,12,None,explanation1)
    check(tabella, expected, None, explanation2 )
    return 2
    
def test_program_3b():
    "\nPrimo test della funzione es3 sulla tabella [[1,2,3,4],[4,1,2,3],[3,4,1,2],[4,3,2,1]]\n"
    tabella=[[1,2,3,4],[4,1,2,3],[3,4,1,2],[4,3,2,1]]
    expected    = [[1, 1, 1, 1], [3, 2, 2, 2], [4, 3, 2, 3], [4, 4, 3, 4]]
    explanation1 = "il valore restituito non e' corretto"
    explanation2 = "la tabella non e' stata modificata correttamente"
    returned    = program.es3(tabella)
    check(returned,16,None,explanation1)
    check(tabella, expected, None, explanation2 )
    return 2
    
def test_program_4a():
    "\nPrimo test della funzione es4 sulla matrice [[1,2,3],[4,5,6],[7,8,9]]\n"
    matrice=[[1,2,3],[4,5,6],[7,8,9]]
    expected    = [[17, 19, 21], [23, 25, 27], [29, 31, 33]]
    explanation1 = "il valore restituito non e' corretto"
    explanation2 = "la matrice non e' stata modificata correttamente"
    returned    = program.es4(matrice)
    check(returned,45,None,explanation1)
    check(matrice, expected, None, explanation2 )
    return 2
    
def test_program_4b():
    "\nSecondo test della funzione es4 sulla matrice [[1,1,1,1],[2,2,2,2],[3,3,3,3],[4,4,4,4]]\n"
    matrice=[[1,1,1,1],[2,2,2,2],[3,3,3,3],[4,4,4,4]]
    expected    = [[13,13,13,13],[16,16,16,16],[19,19,19,19],[22,22,22,22]]
    explanation1 = "il valore restituito non e' corretto"
    explanation2 = "la matrice non e' stata modificata correttamente"
    returned    = program.es4(matrice)
    check(returned,40,None,explanation1)
    check(matrice, expected, None, explanation2 )
    return 2


def test_program_5a():
    "\nPrimo test della funzione es5(). Si tilizza il  file dei film films1.json\n"
    expected    = ['Adventure', 'Comedy', 'Crime', 'Drama', 'Family', 'History', 'Sport', 'Thriller']
    explanation1 = "la lista dei generi restituita non e' corretta"
    explanation2 = "il dizionario prodotto non e' corretto"
    ris=program.es5('films1.json','fES1a.json')
    check(ris,expected,None,explanation1)
    with open('fES1a.json')as f: d1=load(f)
    with open('risES1a.json')as f: d2=load(f)
    check(d1, d2, None, explanation2 )
    return 3    

def test_program_5b():
    "\nSecondo test della funzione es5(). Si utilizza il file dei film films.json\n"
    expected    =['Action', 'Adventure', 'Animation', 'Biography', 'Comedy', 'Crime', 
    'Documentary', 'Drama', 'Family', 'Fantasy', 'Film-Noir', 'History', 'Horror', 
    'Music', 'Musical', 'Mystery', 'Romance', 'Sci-Fi', 'Short', 'Sport', 'Thriller', 
    'War', 'Western']
    explanation1 = "la lista dei generi restituita non e' corretta"
    explanation2 = "il dizionario prodotto non e' corretto"
    ris=program.es5('films.json','fES1b.json')
    check(ris,expected,None,explanation1)
    with open('fES1b.json')as f: d1=load(f)
    with open('risES1b.json')as f: d2=load(f)
    check(d1, d2, None, explanation2 )
    return 3
    

def test_program_6a():
    "\nPrimo test della funzione es6(). Si utilizza il file dei film films1.json\n"
    expected = (1979, 1987) 
    explanation1 = "la funzione deve tornare un il minimo e massimo anno"
    explanation2 = "il dizionario prodotto non e' corretto"
    ris = program.es6('films1.json','fES2a.json')
    check(ris,expected, None, explanation1 )
    with open('fES2a.json')as f: d1=load(f)
    with open('risES2a.json')as f: d2=load(f)
    check(d1,d2, None, explanation2 )
    return 3

    
def test_program_6b():
    "\nSecondo test della funzione es6(). Si utilizza il file dei film films.json\n"
    expected = (1902, 2012)
    explanation1 = "la funzione deve tornare il minimo e massimo anno"
    explanation2 = "il dizionario prodotto non e' corretto"
    ris=program.es6('films.json','fES2b.json')
    check(ris,expected, None, explanation1 )
    with open('fES2b.json')as f: d1=load(f)
    with open('risES2b.json')as f: d2=load(f)
    check(d1,d2, None, explanation2 )
    return 3

   
def test_program_7a():
    "\nPrimo test per  la funzione es7(). Si il file dei film films1.json\n"
    expected = ('Carol Cleveland',  'Terry Jones') 
    explanation1 = "la funzione deve tornare il primo ed ultimo attore in ordine alfabetico"
    explanation2 = "il dizionario prodotto non e' corretto"
    ris=program.es7('films1.json','fES3a.json')
    check(ris,expected, None, explanation1 )
    with open('fES3a.json')as f: d1=load(f)
    with open('risES3a.json')as f: d2=load(f)
    check(d1,d2, None, explanation2 )
    return 4
    
def test_program_7b():
    "\nSecondo test per la funzione es7(). Si il  file dei film films.json\n"
    expected = ('Aamir Khan', 'zge Borak')
    explanation1 = "la funzione deve tornare il primo ed ultimo attore in ordine alfabetico"
    explanation2 = "il dizionario prodotto non e' corretto"
    ris=program.es7('films.json','fES3b.json')
    check(ris,expected, None, explanation1 )
    with open('fES3b.json')as f: d1=load(f)
    with open('risES3b.json')as f: d2=load(f)
    check(d1,d2, None, explanation2 )
    return 4

def test_program_8a():
    '''\nPrimo test sulle Scheda_attore. Si crea la scheda per l'attore Marcello Mastroianni cosi composta:
    
    film   : {'La notte', 'La grande bouffe', 'La dolce vita'}
    generi : {'Drama', 'Comedy'}
    registi: {'Michelangelo Antonioni', 'Federico Fellini', 'Marco Ferreri'}
    anni:   {'2009', '2002', '1979', '1983', '1995', '1985', '1982', '1978'}\n'''
    explanation2 ="il metodo get_generi non e' corretto"
    schedaA=program.Scheda_attore(
                'Marcello Mastroianni',
                {'La grande bouffe', 'La notte', 'La dolce vita', },
                {'Comedy', 'Drama', },
                {'Marco Ferreri', 'Federico Fellini', 'Michelangelo Antonioni', },
                {'2009', '2002', '1979', '1983', '1995', '1985', '1982', '1978'})
    expected = {
                'nome':     'Marcello Mastroianni',
                'films':    {'La notte', 'La grande bouffe', 'La dolce vita'},
                'generi':   {'Drama', 'Comedy'},
                'registi':  {'Michelangelo Antonioni', 'Federico Fellini', 'Marco Ferreri'},
                'anni':     {'1979', '1983', '1985', '2002', '1978', '2009', '1982', '1995'},
            }
    for nome_attr,exp_val in expected.items():
        valore = getattr(schedaA, nome_attr, 'attribute missing')
        check(valore,exp_val,None,"L'attributo '{}' manca o e' sbagliato ({}!={})".format(nome_attr, valore, exp_val))
    check(schedaA.get_generi(),['Comedy','Drama'],None, explanation2)
    return 2

def test_program_8b():
    '''\nSecondo test sulla Scheda_attore. Si controlla la correttezza del metodo aggiorna_scheda.
    Si aggiorna la  scheda per l'attrice Meryl Streep.
    Si parte dalla scheda vuota e  per  l'aggiornamento si usa il file dei film films.json\n'''
    schedaB=program.Scheda_attore('Meryl Streep',set(),set(),set(),set()) # se si inizializza senza valori succedono cose strane
    expected0 = {
        'nome': 'Meryl Streep',
        'films': set(),
        'generi' :set(),
        'registi':set(),
        'anni': set(),
    }
    for nome_attr,exp_val in expected0.items():
        valore = getattr(schedaB, nome_attr, 'attribute missing')
        check(valore,exp_val,None,"L'attributo '{}' manca o e' sbagliato ({}!={})".format(nome_attr, valore, exp_val))
    schedaB.aggiorna_scheda('films.json')
    expected = {
        'films': {'The Deer Hunter', 'Kramer vs. Kramer', 'Manhattan', 'Silkwood', 'Adaptation.',
                'Fantastic Mr. Fox', 'The Hours', 'Julie & Julia', "Sophie's Choice",
                'The Bridges of Madison County', 'Out of Africa'},
        'generi' :{'Adventure', 'Drama', 'Comedy', 'Crime', 'Biography', 'Thriller', 'War', 'Romance',
                'Animation', 'Family'},
        'registi':{'Sydney Pollack', 'Robert Benton', 'Alan J. Pakula', 'Clint Eastwood',
               'Spike Jonze', 'Wes Anderson', 'Mike Nichols', 'Michael Cimino', 'Stephen Daldry',
               'Nora Ephron', 'Woody Allen'},
        'anni': {'1982', '2009', '1985', '1978', '1979', '2002', '1995', '1983'},
    }
    for nome_attr,exp_val in expected.items():
        valore = getattr(schedaB, nome_attr, 'attribute missing')
        check(valore,exp_val,None,"L'attributo '{}' manca o e' sbagliato ({}!={})".format(nome_attr, valore, exp_val))
    return 2

def test_program_8c():
    '''\nTerzo test sulla Scheda_attore. Si controlla la correttezza del metodo aggiorna_scheda.
    Si aggiorna la  scheda per l'attore Brad Pitt.
    Si parte dalla scheda vuota e  per  l'aggiornamento si usa il file dei film films.json\n'''
    schedaC=program.Scheda_attore("Brad Pitt",set(),set(),set(),set()) # se si inizializza senza valori succedono cose strane
    expected0 = {
        'nome': "Brad Pitt",
        'films': set(),
        'generi' :set(),
        'registi':set(),
        'anni': set(),
    }
    for nome_attr,exp_val in expected0.items():
        valore = getattr(schedaC, nome_attr, 'attribute missing')
        check(valore,exp_val,None,"L'attributo '{}' manca o e' sbagliato ({}!={})".format(nome_attr, valore, exp_val))
    schedaC.aggiorna_scheda('films.json')
    expected = {
        'nome': "Brad Pitt",
        'films':{'The Assassination of Jesse James by the Coward Robert Ford', 'Megamind', 'Killing Them Softly',
                 'Se7en', 'The Curious Case of Benjamin Button', 'Inglourious Basterds', 'Burn After Reading',
                 "Ocean's Eleven", 'True Romance', 'Moneyball', 'Sleepers', 'A River Runs Through It', 'Legends of the Fall',
                 'Interview with the Vampire: The Vampire Chronicles', 'Thelma & Louise', 'Snatch.', 'Fight Club',
                 'Meet Joe Black', 'Troy', 'Babel'},
        'generi':{'Biography', 'Sport', 'Fantasy', 'Drama', 'Action', 'Thriller', 'Romance', 'Comedy',
            'Adventure', 'Mystery', 'Western', 'Animation', 'History', 'Crime', 'War', 'Horror',
            'Sci-Fi', 'Family'},
        'registi':{'Andrew Dominik', 'Bennett Miller', 'Barry Levinson', 'Guy Ritchie', 'Joel Coen',
            'and 1 more credit', 'Ethan Coen', 'Alejandro Gonzlez Irritu', 'Tony Scott',
            'Martin Brest', 'Quentin Tarantino', 'Edward Zwick', 'Steven Soderbergh',
            'Wolfgang Petersen', 'Ridley Scott', 'Neil Jordan', 'Robert Redford',
            'Tom McGrath', 'David Fincher'},
            'anni': {'2010', '2001', '1991', '1998', '2008',
                     '2009', '2004', '2011', '2007', '2012',
                     '1994', '2000', '1996', '1992', '1993',
                     '1999', '2006', '1995'},
    }
    for nome_attr,exp_val in expected.items():
        valore = getattr(schedaC, nome_attr, 'attribute missing')
        check(valore,exp_val,None,"L'attributo '{}' manca o e' sbagliato ({}!={})".format(nome_attr, valore, exp_val))
    return 2
    

tests = [
        test_program_1a,test_program_1b,
        test_program_2a,test_program_2b,
        test_program_3a,test_program_3b,
        test_program_4a,test_program_4b,
        test_program_5a, test_program_5b,
        test_program_6a, test_program_6b,
        test_program_7a, test_program_7b,
        test_program_8a, test_program_8b,
        test_program_8c,
        ]


if __name__ == '__main__':
    runtests(tests)

