'''
Progettate una o piu' delle seguenti funzioni 
(all'inizio di ogni funzione viene specificato il numero di punti assegnato dal grader a quella funzione)
Il punteggio complessivo dato dal grader e' il voto della prova di recupero.
La somma dei punteggi ottenibili con gli esercizi e' maggiore di 30, chi supera il 30 otterra' il punteggio 32.

NOTA: il grader testa tutte le funzioni, quindi stampera' degli errori per le funzioni non implementate
'''


def es1(testo,k):
    '''
1) 2 punti
la funzione es1(testo,k) che, presi in input:
- una stringa di testo contenente  unicamente spazi e parole con i 26 caratteri alfabetici  da 'a' a 'z'
- un intero  positivo k,  
restituisce una versione crittografata della stringa di testo. 
Nella stringa crittografata ciascun carattere diverso dallo spazio viene sostituito da un nuovo carattere. 
Il nuovo carattere e' determinato dal valore di k e dalla posizione i che il carattere 
originario occupa nell'ordinamento lessicografico dei 26 caratteri. Piu' precisamente 
il nuovo carattere e' quello che occupa la posizione (i+k)%26 dell'ordinamento 
lessicografico dei 26 caratteri.
Ad esempio per k=2  (ogni occorrenza di 'a' diviene 'c', ogni occorrenza di  'b' diviene 'd' ... 
ogni occorrenza di 'z' diviene 'b'.
quindi per testo= 'lo zaino pesa' e k=2 viene restituita  la stringa  'nq bckpq rguc'
'''
# inserisci qui il tuo codice
    s=''
    for x in testo:
        if x ==' ': s += x
        else: 
            s += chr((ord(x)-ord('a')+k)%26 +ord('a'))
    return s

def es2(dizionario):
    '''
2) 2 punti
la funzione es2(dizionario) che, preso in input:
- un dizionario  avente per chiavi degli interi e per attributi liste di interi, 
restituisce un nuovo dizionario. 
Il nuovo dizionario ha per chiavi  gli interi presenti nelle liste-attributo del dizionario
di partenza  e per attributo chiavi  del dizionario  di partenza.
L'attributo  da associare alla chiave x nel nuovo dizionario viene determinato  in base 
alla regola seguente: tra tutte le chiavi di dizionario che hanno x tra gli elementi della 
loro lista attributo viene selezionata la chiave y  che ha il valore massimo e y 
diviene l'attributo di x nel nuovo dizionario.
Ad esempio per dizionario={1:[1,2,3],2:[1,2,4]} la funzione restituisce il 
nuovo dizionario {1: 2, 2: 2, 3: 1, 4: 2}
'''
# inserisci qui il tuo codice
    d1={}
    for y in dizionario:
        for x in dizionario[y]:
            if x not in d1 or d1[x]<y: d1[x]=y
    return d1

def es3(tabella):
    ''' 
3) 4 punti
la funzione es3(tabella) che presa in input:
- una tabella  di interi (rappresentata tramite lista di liste in cui ciascuna lista e' una riga della tabella) 
modifica distruttivamente la tabella e restituisce il numero totale di elementi che la tabella contiene.
Al termine della funzione, a seguito della modifica,  gli elementi nella tabella 
debbono risultare ordinati in modo crescente per colonna. 
Ad esempio per tabella=[[3,2,1,0],[2,1,3,5],[1,3,2,1]] la funzione restituisce 12 e 
la tabella risulta modificata come segue: [[1, 1, 1, 0], [2, 2, 2, 1], [3, 3, 3, 5]]
'''
# inserisci qui il tuo codice
    h=len(tabella)
    w=len(tabella[0])
    colonna=[]
    for j in range(w): colonna+=[[]]
    for j in range(w):
        for i in range(h):
            colonna[j]+=[tabella[i][j]]
    for j in range(w): colonna[j].sort()
    for i in range(h):
        for j in range(w):
            tabella[i][j]=colonna[j][i]
    return h*w


def es4(matrice):
    '''
4) 4 punti
la funzione es4(matrice) che, presa in input:
- una matrice quadrata di interi (rappresentata tramite lista di liste in cui ciascuna lista e' una riga della tabella)
modifica distruttivamente la matrice e restituisce la somma dei valori presenti nella matrice.
Al termine della funzione il valore matrice[i][j] per ogni riga i e colonna j della matrice 
risulta sostituito con la somma dei valori presenti nela riga i e nella colonna j 
della matrice originale.
Ad esempio  per  matrice=[[1,2,3],[4,5,6],[7,8,9]] la funzione  restituisce il valore 45 e 
la matrice risulta modificata come segue: [[17, 19, 21], [23, 25, 27], [29, 31, 33]]
'''
# inserisci qui il tuo codice
    h=len(matrice)
    righe=[]
    for i in range(h):
        a=0
        for j in range(h):
            a+=matrice[i][j]
        righe+=[a]
    colonne=[]
    for j in range(h):
        a=0
        for i in range(h):
            a+=matrice[i][j]
        colonne+=[a]
    for i in range(h):
        for j in range(h):
            matrice[i][j]=righe[i]+colonne[j]-matrice[i][j]
    return sum(righe)


'''
In tutti gli esercizi che seguono avremo a che fare con  dei files in formato json che 
contengono informazioni su una serie di film. 
Nel seguito indicheremo questo tipo di file come file di film.
Il file di film e' un dizionario e le chiavi del dizionario sono stringhe. 
Ogni stringa contiene il titolo e l'anno di realizzazione di un film (le due informazioni 
sono separate dal carattere ;). attributo di ogni chiave e' un dizionario. 
Il dizionario contiene quattro chiavi: 'ATTORI', 'REGISTI', 'GENERI', 'PAESI'. 
A ciascuna di queste chiavi e' associata una lista.
Ad 'ATTORI' e' associata la lista con i nomi degli attori che hanno partecipato al film.
A 'REGISTI' e' associata la lista con i nomi dei registi del film. 
A 'GENERI' e' associata la lista coi generi cinematografici a cui il film e' riconducibile.
A 'PAESI' e' associata la lista dei paesi in cui il film e' stato lavorato.

ecco di seguito un esempio di voce all'interno di un  file di film:

'The Hill;1965': {'ATTORI': ['Sean Connery',
                              'Harry Andrews',
                              'Ian Bannen',
                              'Alfred Lynch',
                              'Ossie Davis',
                              'Roy Kinnear',
                              'Jack Watson',
                              'Ian Hendry',
                              'Michael Redgrave',
                              'Norman Bird',
                              'Neil McCarthy',
                              'Howard Goorney',
                              'Tony Caunter'],
                   'GENERI': ['Drama', 'War'],
                   'PAESI': ['UK'],
                   'REGISTI': ['Sidney Lumet']} 
                    
'''
import json


def es5(fname,fname1):
    '''
5) 6 punti
la funzione  es5(fname,fname1) che, preso in input l'indirizzo fname di un  file di film, 
costruisce un dizionario che  registra poi  in formato json all'indirizzo fname1 e 
restituisce  la lista (ordinata lessicograficamente) con tutti i generi cinematografici 
presente nel file dei film.
Il dizionario  ha per chiavi  delle stringhe  e per attributi delle liste. 
Le chiavi del dizionario sono i generi cinematografici dei film presenti nel file dei film.
Nelle liste attributo ci sono i nomi dei film che sono riconducibili a quel genere 
cinematografico (ciascuna di queste liste deve risultare ordinata lessicograficamente).
'''
# inserisci qui il tuo codice
    with open(fname, encoding='utf8') as f: d = json.load(f)
    d1={}
    ins=set()
    for film in d:
        coppia=film.split(';')
        for g in d[film]['GENERI']:
            ins=ins | set(d[film]['GENERI'])
            if g in d1: 
                d1[g]+=[coppia[0]]
            else: d1[g]=[coppia[0]]  
    for k in d1: d1[k].sort()   # ce ne eravamo dimenticati nel produrre i dati dei test
    with open(fname1, 'w', encoding='utf8') as f:  json.dump(d1,f)
    ordinate = sorted(d1.keys())
    return ordinate


def es6(fname,fname1):
    '''
6) 6 punti
la funzione es6(fname,fname1) che, preso in input l'indirizzo fname di un  file di film
costruisce un dizionario che  registra poi  in formato json all'indirizzo fname1. 
Il dizionario  ha per chiavi  degli interi e per 
attributi delle liste. Le chiavi del dizionario sono gli anni in cui sono stati realizzati 
i film presenti nel file di film e l'attributo di un dato anno e' la lista dei film del file 
girati in quell'anno ( ciascuna  lista deve essere ordinata lessicograficamente).
La funzione ritorna la coppia (tupla) con il primo e ultimo anno trovato.
'''
# inserisci qui il tuo codice
    with open(fname, encoding='utf8') as f: d = json.load(f)
    d1={}
    for film in d:
        coppia=film.split(';')
        if int(coppia[1]) in d1: d1[int(coppia[1])]+=[coppia[0]]
        else:d1[int(coppia[1])]=[coppia[0]]
    for x in d1: d1[x].sort()
    with open(fname1, 'w', encoding='utf8') as f: json.dump(d1,f)
    ordinate = sorted(d1.keys())
    return ordinate[0], ordinate[-1]



def es7(fname,fname1):
    '''
7) 6 punti
la funzione es7(fname,fname1) che, preso in input l'indirizzo fname di un 
file di film, costruisce un dizionario che  registra poi  in formato json all'indirizzo fname1. 
Il dizionario  ha per chiavi  e attributi delle stringhe. 
Le chiavi del dizionario sono  nomi di attori che hanno recitato nei film presenti nel file di film. 
Ad ogni attore viene associato il genere di film in cui l'attore e' 
specializzato (vale a dire il genere che predomina tra i generi dei film in cui ha recitato).
Nel caso in cui per l'attore non ci sia un genere che predomina sugli altri, allora l'attore non 
deve comparire nel dizionario.
La funzione torna la coppia (tupla) con il primo ed ultimo attore in ordine alfabetico.
'''
# inserisci qui il tuo codice
    with open(fname, encoding='utf8') as f: d = json.load(f)
    d1={}
    for film in d:
        cast=d[film]['ATTORI']
        genere=d[film]['GENERI']
        for attore in cast:
            if attore in d1:
                for g in genere:
                    if g in d1[attore]: 
                        d1[attore][g]+=1
                    else: 
                        d1[attore][g]=1
            else:
                d1[attore]={}
                for g in genere: d1[attore][g]=1
    d2={}
    for attore in d1:
        generi=set()
        m=0
        for g in d1[attore]: m=max(m,d1[attore][g])
        for g in d1[attore]:
            if d1[attore][g]==m: generi.add(g)
        if len(generi)==1 :d2[attore]=generi.pop()
    with open(fname1, 'w', encoding='utf8') as f: json.dump(d2,f)
    ordinate = sorted(d2.keys())
    return ordinate[0], ordinate[-1]





class Scheda_attore:
    '''
    8) 6 punti
    l'esercizio richiede di implementare la classe Scheda_attore composta da un inizializzatore e due metodi
    '''    
    def __init__(self, nome, films=set(), generi=set(), registi=set(), anni=set()):
        '''Ciascun oggetto  della classe ha 4 attributi da specificare al momento 
        della creazione: nome, films, generi e registi. 
        Il primo attributo (nome) e' una stringa (il nome di un attore) gli altri tre sono insiemi. 
         - films e' l'insieme dei film in cui l'attore ha recitato.
         - generi e' l'insieme dei generi dei film in cui l'attore ha recitato
         - registi  e' l'insieme  dei registi che hanno diretto l'attore
         - anni e' l'insieme degli anni in cui ha fatto film. '''
        # inserisci qui il tuo codice
        self.nome   = nome
        self.films  = films
        self.generi = generi
        self.registi= registi
        self.anni   = anni

    def get_generi(self):
       '''il metodo get_generi restituisce una lista contenente i generi della scheda in ordine lessicografico.'''
       # inserisci qui il tuo codice
       return sorted(self.generi)
    
    def aggiungi_film(self, film, titolo, anno):
        '''il metodo aggiungi_film aggiunge i dati di un film alla scheda dell'attore, se ha fatto parte del film.'''
        if self.nome in film['ATTORI']:
            self.films.add(titolo)
            self.registi |= set(film['REGISTI'])
            self.generi  |= set(film['GENERI' ])
            self.anni.add(anno)

    def aggiorna_scheda(self, fname):
        '''il metodo aggiorna_scheda , dato l'indirizzo di un file di film aggiorna gli attributi della scheda 
        tenendo conto degli eventuali film presenti nel file dei film in cui compare l'attore della scheda.
        Per farlo usa il metodo aggiungi_film'''
        # inserisci qui il tuo codice
        with open(fname, encoding='utf8') as f:
            d1 = json.load(f)
        attore=self.nome
        for tit_anno, film in d1.items():
            titolo,anno = tit_anno.split(';')
            self.aggiungi_film(film, titolo, anno)

